package was7_webservice;

import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.core.runtime.Status;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends Plugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "WAS7_webservice";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	  public void log(String msg) {
	      log(msg, null);
	   }
	   public void log(String msg, Exception e) {
	      getLog().log(new Status(Status.INFO, PLUGIN_ID, Status.OK, msg, e));
	   }
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugins#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
	
	public static String getPluginDir() {
		Bundle bundle = Platform.getBundle(PLUGIN_ID);
		   Path path = new Path("/");
		   URL fileURL = FileLocator.find(bundle, path, null);
		   try {
			return  FileLocator.resolve(fileURL).getFile();
		} catch (IOException e) {
	
			e.printStackTrace();
			return null;
		}
	}

}
