/**
 * 
 */
package was7_webservice;

import ilog.rules.studio.res.ui.generator.impl.wizard.IlrFileGeneratorWizard;
import ilog.rules.studio.res.ui.generator.impl.wizard.page.IlrTraceFilterWizardPage;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.actions.WorkspaceModifyOperation;

/**
 * @author WebSphere ILOG BRMS Support
 * 
 */
public class WAS7CreationWizard extends IlrFileGeneratorWizard {

	protected IlrTraceFilterWizardPage tracePage;
	protected WAS7ServerSetupPage serverPage;

	public WAS7CreationWizard() {
		super();
	}

	static String FILE_HEADER = "// Automatically Generated with WAS7 WebService Generator";

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 * add pages to the wizard to collect the information
	 * required to build the page.
	 * The IlrFileGenerator takes care of 
	 *  the project
	 *  the ruleapp
	 *  the rulesets
	 *  This method will adds the page to collect the information 
	 *  regarding the web service and the traces.
	 */
	public void addPages() {
		serverPage = new WAS7ServerSetupPage(
				"WAS7 Server Configuration Selection");
		addPage(serverPage);

		tracePage = new IlrTraceFilterWizardPage("trace");
		addPage(tracePage);
	}

	@Override
	public boolean performFinish() {
		// TODO Auto-generated method stub
		WorkspaceModifyOperation operation = new WorkspaceModifyOperation(
				ResourcesPlugin.getWorkspace().getRoot()) {
			protected void execute(IProgressMonitor paramIProgressMonitor)
					throws CoreException, InvocationTargetException,
					InterruptedException {
				Was7Generator localGenerator = (Was7Generator) WAS7CreationWizard.this
						.getGenerator();
				try {
					localGenerator.setFileHeader(FILE_HEADER);
					WAS7CreationWizard.this.serverPage
							.saveProperties(localGenerator);
					WAS7CreationWizard.this.tracePage
							.saveProperties(localGenerator);

				} catch (Exception localException) {
					throw new InvocationTargetException(localException);
				} finally {
					paramIProgressMonitor.done();
				}
			}
		};
		try {
			getContainer().run(false, true, operation);
		} catch (InterruptedException localInterruptedException) {
			Activator.getDefault().log( "Unable to complete the operation.",
					localInterruptedException);
		} catch (InvocationTargetException localInvocationTargetException) {
			Activator.getDefault().log( "Unable to complete the operation.",
					localInvocationTargetException);
		}
		return true;
	}

}
